## pyferret 7.4.4

=== Makefile ===
#
# Makefile for building and installing the pyferret module
# and the modules and libraries associated with it.
#

# Site-specific defines
include site_specific.mk

# Platform-specific defines
include platform_specific.mk.$(BUILDTYPE)

ifeq ("$(BUILDTYPE)", "intel-mac")
	COPY_DYLIBS = - ( cd $(DIR_PREFIX); ./copy_dylibs.sh )
else
	COPY_DYLIBS =
endif

.PHONY : all
all : optimized

.PHONY : optimized
optimized :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer optimized
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : beta
beta :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer beta
	$(MAKE) pymod_optimized_build
	$(MAKE) pymod_optimized_install
	$(MAKE) externals_optimized
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

.PHONY : debug
debug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer debug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c,
## which causes it to print (append) all memory allocations, reallocations,
## and frees to file "memorydebug.txt".  Initialize allocated memory with
## non-zero values.  Expect this to be a lot slower due to all the
## (intentionally inefficient but safe) file operations.
.PHONY : memorydebug
memorydebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer memorydebug
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_build
	$(MAKE) "CFLAGS = $(CFLAGS) -DMEMORYDEBUG" pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following defines GRDELDEBUG used by fer/grdel, which causes it
## to create a grdeldebug.log file with all the graphics commands issued
.PHONY : grdeldebug
grdeldebug :
	mkdir -p $(DIR_PREFIX)/lib
	$(COPY_DYLIBS)
	$(MAKE) -C $(DIR_PREFIX)/fer grdeldebug
	$(MAKE) pymod_debug_build
	$(MAKE) pymod_debug_install
	$(MAKE) externals_debug
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix

## The following does an optimized build of libpyferret.so
.PHONY : pymod_optimized_build
pymod_optimized_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet build )

## The following installs libpyferret.so and optimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_optimized_install
pymod_optimized_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -DNDEBUG -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_optimized
externals_optimized :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions optimized

## The following does a debug build of libpyferret.so
.PHONY : pymod_debug_build
pymod_debug_build :
	rm -fr $(DIR_PREFIX)/build $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py build -g )

## The following installs libpyferret.so and unoptimized
## versions of all the python scripts into $(DIR_PREFIX)/install.
.PHONY : pymod_debug_install
pymod_debug_install :
	rm -fr $(DIR_PREFIX)/install
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -UNDEBUG -O0 -g" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O0 --prefix=$(DIR_PREFIX)/install )

.PHONY : externals_debug
externals_debug :
	$(MAKE) "FER_DIR = $(DIR_PREFIX)/install" -C $(DIR_PREFIX)/external_functions debug

## Remove everything that was built
.PHONY : clean
clean :
	$(MAKE) -C $(DIR_PREFIX)/bench clean
	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix clean
	$(MAKE) -C $(DIR_PREFIX)/external_functions clean
	rm -fr $(DIR_PREFIX)/install $(DIR_PREFIX)/build ferret.jnl*
	find $(DIR_PREFIX)/pviewmod -name '*.py[co]' -delete
	find $(DIR_PREFIX)/pyfermod -name '*.py[co]' -delete
	$(MAKE) -C $(DIR_PREFIX)/fer clean
	rm -fr $(DIR_PREFIX)/lib $(DIR_PREFIX)/dylibs

## Install Ferret binaries, scripts, and other files into $(INSTALL_FER_DIR)
.PHONY : install
install :
	rm -f pyferret-latest-local.tar.gz
	bin/make_dist_tar . latest local . -y
	mkdir -p $(INSTALL_FER_DIR)
	mv -f pyferret-latest-local.tar.gz $(INSTALL_FER_DIR)
	( cd $(INSTALL_FER_DIR) ; tar xz --strip-components=1 -f pyferret-latest-local.tar.gz )

## The following is for installing the updated ferret_ef_meme_subsc.so, libpyferret.so,
## and PyFerret python scripts into $(INSTALL_FER_DIR)/lib without having to use the
## distribution tar file.  Also copies all the PyFerret Fortran external function to
## the $(INSTALL_FER_DIR)/ext_func/pylibs directory.
.PHONY : update
update :
	mkdir -p $(INSTALL_FER_DIR)/lib
	find $(DIR_PREFIX)/external_functions -type f -perm -100 -name \*.so -exec cp {} $(INSTALL_FER_DIR)/ext_func/pylibs \;
	( cd $(DIR_PREFIX) ; \
	  export CC=$(CC) ; \
	  export CFLAGS="$(CFLAGS) -O" ; \
	  export BUILDTYPE=$(BUILDTYPE) ; \
	  export NETCDF_LIBDIR=$(NETCDF_LIBDIR) ; \
	  export HDF5_LIBDIR=$(HDF5_LIBDIR) ; \
	  export SZ_LIBDIR=$(SZ_LIBDIR) ; \
	  export CAIRO_LIBDIR=$(CAIRO_LIBDIR) ; \
	  export PIXMAN_LIBDIR=$(PIXMAN_LIBDIR) ; \
	  export PANGO_LIBDIR=$(PANGO_LIBDIR) ; \
	  export GLIB2_LIBDIR=$(GLIB2_LIBDIR) ; \
	  export GFORTRAN_LIB=$(GFORTRAN_LIB) ; \
	  export BIND_AND_HIDE_INTERNAL=$(BIND_AND_HIDE_INTERNAL) ; \
	  $(PYTHON_EXE) setup.py --quiet install -O2 --prefix=$(INSTALL_FER_DIR) )

## Compare results from executing the RUN_TESTS.sh test suite with those saved under bench/test_results
.PHONY : check
check :
	$(MAKE) -C $(DIR_PREFIX)/bench check

##

=== bench/Makefile ===
#
# Makefile for the PyFerret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Compare results from executing the RUN_TESTS.sh test suite with those saved under bench/test_results
.PHONY: check
check: run_tests
	@echo 'Differences in the generated bench PDF and PNG files versus those in bench/test_results'
	-@for img in *.pdf *.png ; \
	do \
	    if diff -q $$img test_results/$$img ; then \
	        echo "Files $$img and test_results/$$img are identical"; \
	    else \
	        compare $$img test_results/$$img "$$img"_diff.png ; \
	    fi \
	done
	-@( datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ; \
	    diff all_$${datetag}*_ncdump test_results/pyferret_run_tests_ncdump 1> pyferret_run_tests_ncdump.diff 2>&1 ; \
	    diff all_$${datetag}*_err test_results/pyferret_run_tests_err 1> pyferret_run_tests_err.diff 2>&1 ; \
	    diff all_$${datetag}*_log test_results/pyferret_run_tests_log 1> pyferret_run_tests_log.diff 2>&1 \
	)
	@echo ''
	@echo 'Inspect the *_diff.png files for actual differences in the images'
	@echo 'Inspect the pyferret_run_tests_*.diff files for actual differences in the output'

## Execute the RUN_TESTS.sh test suite
.PHONY: run_tests
run_tests:
	@if [ `which pyferret` = "" -o "$(FER_DIR)" = "" ]; then \
	    echo "*** PyFerret must be installed and the ferret_paths script must have sourced for these tests ***" ; \
	    exit 1 ; \
	fi
	( SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)"; export SED_EXTREGEX_FLAG; ./RUN_TESTS.sh `which pyferret` "$(PYFER_EXTERNAL_FUNCTIONS)" )

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.ps* *.eps* *.png* *.pdf* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== external_functions/Makefile ===
#
# Top level Makefile for Ferret External Functions
#
# September 09 1998
# Jonathan Callahan
#
# ACM 1/2002  add fft directory back in: lsl_lowpass, inverse fcn.
# ACM 4/2006  link all functions that are distributed statically; the
#             directories below compile only example functions, functions
#             under development, or used locally by PMEL/TMAP (e.g.romea fcns)
 
#
# Site-specific defines
#
include ../site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include ../platform_specific.mk.$(BUILDTYPE)

#
# Macro Definitions
#

DIRS = ef_utility contributed decimate examples fft las statistics stringfcns
MOREDIRS = cmprsi_by extrema featurecollections gridding tax_times

#
# Targets
#

.PHONY : all
all: optimized

.PHONY : optimized
optimized:
	$(MAKE) "CFLAGS = $(CFLAGS) -O" "FFLAGS = $(FFLAGS) -O" build

.PHONY : debug
debug:
	$(MAKE) "CFLAGS = $(CFLAGS) -O0 -g" "FFLAGS = $(FFLAGS) -O0 -g" build

.PHONY: build
build:
	for i in $(DIRS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: buildmore
buildmore:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: install
install:
	for i in $(DIRS) ; do \
            if ! $(MAKE) -C $$i install ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: installmore
installmore:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i install ; then \
                exit 1 ; \
            fi ; \
        done

.PHONY: clean
clean:
	for i in $(DIRS) $(MOREDIRS) ; do \
            if ! $(MAKE) -C $$i clean ; then \
                exit 1 ; \
            fi ; \
        done

#
# End of Makefile
#

=== fer/Makefile ===
#
# Simple makefile for launching other makes to build all the ferret libraries
#

#
# Site-specific defines
#
include ../site_specific.mk

#
# include platform specific definitions of:
#       CC, FC, RANLIB, CFLAGS, FFLAGS, PPLUS_FFLAGS
#
include ../platform_specific.mk.$(BUILDTYPE)

PLATFORM := $(shell uname -rs)
DATE := $(shell /bin/date +%D)

#
# Macros
#

DIRS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
       ino mem plt pyf rpn stk utl xeq special

LIBS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
       ino mem plt pyf rpn stk utl xeq 

#
# Targets
#

.PHONY : all
all: optimized


.PHONY : optimized
optimized:
	$(MAKE) "CFLAGS = $(CFLAGS) $(OPT_FLAGS)" \
		"FFLAGS = $(FFLAGS) $(OPT_FLAGS)" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
		"VERSION_INFO = (optimized)" \
		build

.PHONY : beta
beta:
	$(MAKE) "CFLAGS = $(CFLAGS) $(OPT_FLAGS)" \
		"FFLAGS = $(FFLAGS) $(OPT_FLAGS)" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
		"VERSION_INFO = (beta/optim)" \
		build

.PHONY : debug
debug:
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS)"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"VERSION_INFO = (beta/debug)" \
		build

## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c, 
## which causes it to print (append) all memory allocations, reallocations, 
## and frees to file "memorydebug.txt".  Initialize allocated memory with 
## non-zero values.  Expect this to be a lot slower due to all the 
## (intentionally inefficient but safe) file operations.
.PHONY : memorydebug
memorydebug:
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS) -DMEMORYDEBUG"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"VERSION_INFO = (beta/debug)" \
		build


## The definition of GRDELDEBUG is observed by fer/grdel, which causes it
## to create a grdeldebug.log file with all the graphics commands issued
.PHONY : grdeldebug
grdeldebug:
	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS) -DGRDELDEBUG"  \
		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
		"VERSION_INFO = (beta/debug)" \
		build

.PHONY: profiling
profiling:
	$(MAKE) "CFLAGS = $(CFLAGS) $(PROF_FLAGS) "  \
		"FFLAGS = $(FFLAGS) $(PROF_FLAGS) -fbounds-check" \
		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PROF_FLAGS)" \
		"LDFLAGS = $(LDFLAGS) $(PROF_FLAGS)" \
		"VERSION_INFO = (profiling)" \
		build

.PHONY : build
build: update special_code ppl_libraries fmt_libraries fer_libraries


.PHONY : update
update:
	rm -f special/xmake_date_data.[Ffo]
	sed "s&xxxxxxxx&$(DATE)&" < special/xmake_date_data.template > special/xmake_date_data.F
	rm -f special/xrevision_type_data.[Ffo]
	sed -e 's&mmmmmmmm&$(VERSION_INFO)&' -e 's&(/&(&' -e 's&/)&)&' < special/xrevision_type_data.template > special/xrevision_type_data.F 
	rm -f special/xplatform_type_data.[Ffo]
	sed -e 's&mmmmmmmm&$(PLATFORM)&' -e 's&(/&(&' -e 's&/)&)&' < special/xplatform_type_data.template > special/xplatform_type_data.F 


.PHONY : special_code
special_code: update
	$(MAKE) -C special all


.PHONY : ppl_libraries
ppl_libraries:
	$(MAKE) -C ../ppl


.PHONY : fmt_libraries
fmt_libraries:
	$(MAKE) -C ../fmt/src


.PHONY : fer_libraries
fer_libraries: update
	for i in $(LIBS) ; do \
            if ! $(MAKE) -C $$i ; then \
                exit 1 ; \
            fi ; \
        done


.PHONY : clean
clean: ppl_clean fmt_clean fer_clean
	rm -f ../lib/*


.PHONY : ppl_clean
ppl_clean:
	$(MAKE) -C ../ppl clean


.PHONY : fmt_clean
fmt_clean:
	$(MAKE) -C ../fmt/src clean


.PHONY : fer_clean
fer_clean:
	for i in $(DIRS) ; do \
            $(MAKE) -C $$i clean ; \
        done
	rm -f special/xmake_date_data.F special/xrevision_type_data.F special/xplatform_type_data.F

#
# End of Makefile
#

=== external_functions/date_and_time/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
# dec-00 adapted for "date_and_time" function
# 2/01 *sh* - restored the -C qualifier for debug target

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

DAT_OBJS = date_decode.o time_decode.o secs_to_ymdhms.o

#
# Rules
#

.c.so:
	$(CC) $(CFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o $(SYSLIBS) -o $*.so

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	date_decode.o time_decode.o secs_to_ymdhms.o date1900.o date1900.so minutes24.o minutes24.so days1900toymdhms.o days1900toymdhms.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/extrema/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# ACM 2/2001  debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk
 
#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.o:
	$(F77) $(FFLAGS) -c $<

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o minminmax.o maxminmax.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:    minminmax.o maxminmax.o findhi.so findlo.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/godae_obs/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# dec-00 adapted for "godae_obs" function
# ACM 2/2001

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

GOB_OBJS = ocn_obs.o

#
# Rules
#

.c.so:
	$(CC) $(CFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(GOB_OBJS) $*.o $(SYSLIBS) -o $*.so

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(GOB_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	ocn_obs.o godae_obs.o godae_obs.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/hinterp/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	rect_to_curv.so curv_to_rect_map.so curv_to_rect.so curv_range.so
all:	curv_to_rect_fsu.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/obs_viz/Makefile ===
#
# Makefile for Ferret External Functions
#
# 2/01 *sh*

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

DAT_OBJS = flag2ddups.o

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	$(DAT_OBJS) scat2ddups.o scat2ddups.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/stringfcns/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.
#  KMS 4/2018  do not build efstrings - crashes on MacOSX and 32-bit Linux
#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	str_missing.so maxstrlen.so pass_thru_string.so \
	pick_a_string.so string_cat3.so string_len_sum.so \
	strings_as_args.so length_of_strings.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/tax_times/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	tax_index_datestring.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/transpose/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# *acm* 1/2001 - incorporate "make debug" as per SH Makefiles
#  acm  2/2001   debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk
 
#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(F77) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#
# all:    transpose_xz.so transpose_xy.so transpose_xt.so transpose_yz.so transpose_yt.so transpose_zt.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
pyferret (7.4.4-1) unstable; urgency=medium

  * New upstream release
  * Don't hard-code xz compresson

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Dec 2018 09:19:53 +0000

pyferret (7.4.3-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.1
  * Add watch file
  * Update  X-Python*-Version lines in d/control

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Sep 2018 07:31:34 +0100

=== debian/control ===
Source: pyferret
Standards-Version: 4.2.1
Homepage: http://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
Vcs-Browser: https://salsa.debian.org:/science-team/pyferret
Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
X-Python3-Version: >= 3.6
Build-Depends: debhelper (>= 10),
 gfortran,
 pkg-config,
 csh,
 dh-python,
 libreadline-dev, 
 libcurl4-openssl-dev | libcurl-dev, 
 libncurses-dev, 
 libnetcdf-dev (>= 4.3.0),
 libnetcdff-dev,
 libxpm-dev, 
 libxt-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 python-dev,
 python3-dev,
 python-numpy,
 python3-numpy,
 python-future,
 python3-future,
 ferret-vis

Package: python-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python:Depends}, python-future
Recommends: ferret-datasets, python-scipy, python-pyshp
Description: Python wrapper for the Ferret visualization and analysis environment
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python wrapper for Ferret

Package: python3-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python3:Depends}, python3-future
Recommends: ferret-datasets, python3-scipy, python3-pyshp
Description: Python3 wrapper for the Ferret visualization and analysis environment,
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python3 wrapper for Ferret

## pyferret 7.5.0

=== Makefile ===
--- 
+++ 
@@ -23,16 +23,6 @@
 	mkdir -p $(DIR_PREFIX)/lib
 	$(COPY_DYLIBS)
 	$(MAKE) -C $(DIR_PREFIX)/fer optimized
-	$(MAKE) pymod_optimized_build
-	$(MAKE) pymod_optimized_install
-	$(MAKE) externals_optimized
-	$(MAKE) -C $(DIR_PREFIX)/bin/build_fonts/unix
-
-.PHONY : beta
-beta :
-	mkdir -p $(DIR_PREFIX)/lib
-	$(COPY_DYLIBS)
-	$(MAKE) -C $(DIR_PREFIX)/fer beta
 	$(MAKE) pymod_optimized_build
 	$(MAKE) pymod_optimized_install
 	$(MAKE) externals_optimized
@@ -210,4 +200,8 @@
 check :
 	$(MAKE) -C $(DIR_PREFIX)/bench check
 
+.PHONY : check_noremote
+check_noremote :
+	$(MAKE) -C $(DIR_PREFIX)/bench check_noremote
+
 ##

=== bench/Makefile ===
#
# Makefile for the PyFerret bench subdirectory
#

# include platform specific macro definitions for make_stream_file
include ../site_specific.mk
include ../platform_specific.mk.$(BUILDTYPE)

## Run all the benchmark tests, including those requiring remote data
## (environment variable SKIP_REMOTE is empty)
.PHONY: check
check:
	@$(MAKE) "SKIP_REMOTE=" run_tests
	@$(MAKE) "SKIP_REMOTE=" compare_plots
	@$(MAKE) "SKIP_REMOTE=" compare_logs

## Run all the benchmark tests except those requiring remote data
## (environment variable SKIP_REMOTE is not empty)
.PHONY: check_noremote
check_noremote:
	@$(MAKE) "SKIP_REMOTE=XXXX" run_tests
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_plots
	@$(MAKE) "SKIP_REMOTE=XXXX" compare_logs

## Execute the RUN_TESTS.sh test suite
## If the environment variable SKIP_REMOTE is not empty, skips tests requiring remote data
.PHONY: run_tests
run_tests:
	@( \
	    ferret_exe=`which pyferret` ;\
	    if [ $$ferret_exe = "" -o "$(FER_DIR)" = "" ] ; then \
	        echo "*** PyFerret must be installed and the ferret_paths script must have sourced for these tests ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Using $$ferret_exe" ;\
	    SED_EXTREGEX_FLAG="$(SED_EXTREGEX_FLAG)" ;\
	    export SED_EXTREGEX_FLAG ;\
	    ./RUN_TESTS.sh $$ferret_exe "$(PYFER_EXTERNAL_FUNCTIONS)" \
	)

## Compare the plots from executing the RUN_TESTS.sh test suite with those saved.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_plots
compare_plots:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    echo "Comparing PNG and PDF files to those in bench/$$results_dir" ;\
	    for img in `find . -name '*.p[nd][gf]' -a \! -regex '.*_diff.png' -exec basename {} \; | sort -u` ; do \
	        if [ ! -f $$img ] ; then \
	            echo "*** File $$img is missing ***" ;\
	        elif [ ! -f $$results_dir/$$img ] ; then \
	            echo "*** File $$results_dir/$$img is missing ***" ;\
	        elif diff -q $$img $$results_dir/$$img ; then \
	            echo "Files $$img and $$results_dir/$$img are identical" ;\
	        else \
	            compare $$img $$results_dir/$$img $${img}_diff.png ; \
	        fi ;\
	    done \
	)
	@echo ''
	@echo 'Inspect the *_diff.png files for actual differences in the images'
	@echo ''

## Compare the log, err, and ncdump results from executing the RUN_TESTS.sh test suite.
## If the environment variable SKIP_REMOTE is empty, compares to those under "test_result";
## otherwise compares to those under "test_results_noremote"
.PHONY: compare_logs
compare_logs:
	-@( \
	    if [ -z "$(SKIP_REMOTE)" ] ; then \
	        results_dir="test_results" ;\
	    else \
	        results_dir="test_results_noremote" ;\
	    fi ;\
	    datetag=`date +'%d%h%yAT'|tr '[A-Z]' '[a-z]'` ;\
	    logfile=`/bin/ls -1 all_$${datetag}*_log` ;\
	    if [ -z "$$logfile" ] ; then \
	        echo "*** No run_tests results log file from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    if [ `echo "$${logfile[@]}" | wc -l` -ne 1 ] ; then \
	        echo "*** Multiple run_tests results logs from today found ***" ;\
	        exit 1 ;\
	    fi ;\
	    echo "Comparing $$logfile to bench/$$results_dir/pyferret_run_tests_log" ;\
	    diff $$logfile $$results_dir/pyferret_run_tests_log 1> pyferret_run_tests_log.diff 2>&1 ;\
	    errfile=`echo $$logfile | sed -e "s%log%err%"` ;\
	    echo "Comparing $$errfile to bench/$$results_dir/pyferret_run_tests_err" ;\
	    diff $$errfile $$results_dir/pyferret_run_tests_err 1> pyferret_run_tests_err.diff 2>&1 ;\
	    ncdfile=`echo $$logfile | sed -e "s%log%ncdump%"` ;\
	    echo "Comparing $$ncdfile to bench/$$results_dir/pyferret_run_tests_ncdump" ;\
	    diff $$ncdfile $$results_dir/pyferret_run_tests_ncdump 1> pyferret_run_tests_ncdump.diff 2>&1 ;\
	    echo '' ;\
	    echo 'Inspect the pyferret_run_tests_*.diff files for actual differences in the output' \
	)
	@echo ''

.PHONY: clean
clean:
	rm -f all_*_ncdump all_*_err all_*_log all_*_ncdump_orig all_*_err_orig all_*_log_orig cleanups.sed
	rm -f *.ps* *.eps* *.png* *.pdf* *.diff* ferret.jnl*
	rm -f `cat TRASH_FILES`
	rm -f all_ncdump.out fort.41 make_stream_file
	rm -fr subdir tmp aggf

make_stream_file: make_stream_file.F
	$(FC) $(FFLAGS) make_stream_file.F -o make_stream_file

#
# End of Makefile
#

=== fer/Makefile ===
--- 
+++ 
@@ -20,10 +20,10 @@
 # Macros
 #
 
-DIRS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
+DIRS = agg ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
        ino mem plt pyf rpn stk utl xeq special
 
-LIBS = ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
+LIBS = agg ccr cferbind ctx dat doo efi efn ef_utility fmt gnl grdel \
        ino mem plt pyf rpn stk utl xeq 
 
 #
@@ -42,20 +42,12 @@
 		"VERSION_INFO = (optimized)" \
 		build
 
-.PHONY : beta
-beta:
-	$(MAKE) "CFLAGS = $(CFLAGS) $(OPT_FLAGS)" \
-		"FFLAGS = $(FFLAGS) $(OPT_FLAGS)" \
-		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(PPLUS_OPT_FLAGS)" \
-		"VERSION_INFO = (beta/optim)" \
-		build
-
 .PHONY : debug
 debug:
 	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS)"  \
 		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
 		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
-		"VERSION_INFO = (beta/debug)" \
+		"VERSION_INFO = (debug)" \
 		build
 
 ## The definition of MEMORYDEBUG is observed by fer/special/FerMem_routines.c, 
@@ -68,7 +60,7 @@
 	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS) -DMEMORYDEBUG"  \
 		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
 		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
-		"VERSION_INFO = (beta/debug)" \
+		"VERSION_INFO = (memorydebug)" \
 		build
 
 
@@ -79,7 +71,7 @@
 	$(MAKE) "CFLAGS = $(CFLAGS) $(DBG_FLAGS) -DGRDELDEBUG"  \
 		"FFLAGS = $(FFLAGS) $(DBG_FLAGS) -fbounds-check" \
 		"PPLUS_FFLAGS = $(PPLUS_FFLAGS) $(DBG_FLAGS)" \
-		"VERSION_INFO = (beta/debug)" \
+		"VERSION_INFO = (grdeldebug)" \
 		build
 
 .PHONY: profiling

=== external_functions/cat/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	list_good.so xcat.so ycat.so zcat.so tcat.so xreverse.so yreverse.so zreverse.so treverse.so
all:	list_good.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/closest_in_list/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 2/26/00
#

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	closest_in_zlist.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/cmprsi_by/Makefile ===
#
# Makefile for Ferret External Functions
#
# *sh* 12/27/00
# *sh* 1/02 -- updated to add expndi_by
# *sh* 2/02 -- updated to add expndi_by_z
# *acm*2/02 -- cmprsi_by has been replaced by family of compress_by
#              functions, which are internally linked.
# acm* 4/13 -- new expndi_by_m_counts
#

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	expndi_by.so expndi_by_z.so expndi_by_t.so cmprsi_by.so expndi_by_z_counts.so 
all:	expndi_by_m_counts.so 

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/contributed/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
# *sh* 2/2000 - removed SAMPLEIJ from target list (replaced by SAMPLEXY)
#
# *acm* 1/2001 - incorporate "make debug" as per SH Makefiles
#  acm  2/2001   debug macros
#  acm  5/2007   removed fill_xy from target list; now statically-linked.

#
# include site-specific definitions
#
include ../ef_utility/site_specific.mk

#
# include platform-specific definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/convolve/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
# *acm* 1/2001 - add "make debug" target as per SH Makefiles
#  ACM  2/2001    use debug macros

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

# all:	convolvei.so convolvej.so convolvek.so convolvel.so
all:

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/date_and_time/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o $(SYSLIBS) -o $*.so
 
 .F.so:
-	$(F77) $(FFLAGS) -c $<
+	$(FC) $(FFLAGS) -c $<
 	$(LD) $(LD_DYN_FLAGS) $(DAT_OBJS) $*.o $(SYSLIBS) -o $*.so
 
 #

=== external_functions/decimate/Makefile ===
#
# Makefile for Ferret External Functions
#
#
# include platform specific macro definitions
#
include ../ef_utility/site_specific.mk
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)
 
#
# Macros
#

.SUFFIXES: .so
SUB_OBJS = piecewise_subs.o

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $(SUB_OBJS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

#all:	$(SUB_OBJS) piecewise.so piecewise3.so piecewise1.so piecewise2.so separate.so sample_fast_i.so sample_rows.so apply_qc.so sample_fast_i_str.so sample_rows.so
all:	$(SUB_OBJS) piecewise3.so separate.so separate_str.so sample_fast_i.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) -g -Ddebug" "CFLAGS = $(CFLAGS) -g -Ddebug"  all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== external_functions/eof/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM  2/2001  debug macros
#  ACM  Jul 2001 Move to statically linked code in fer/efi.  name functions
#                eofspace, eofstat, eoftfunc; with same code as in fer/efi,
#                but with different INCLUDE statements for use in testing
#                as dynamically-linked functions.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk

#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

SUB_OBJS = eofsubs.o

#
# Rules
#

#   once eof_space etc are linked into Ferret dont need SUB_OBJS

.F.so:
	$(FC) $(FFLAGS) -c $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	eofsubs.o eof_space_tgap.so eof_tfunc_tgap.so eof_stat_tgap.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

# To make a tarfile with the older functions that work on gappy timeseries:
# make; make tarfile
tarfile:
	rm -f fer_eof_gappy_timeseries_fcns.tar*
	tar cf fer_eof_gappy_timeseries_fcns.tar *.so
	gzip -9 fer_eof_gappy_timeseries_fcns.tar

#
# End of Makefile
#

=== external_functions/examples/Makefile ===
#
# Makefile for Ferret External Functions
#
# January 20 1998
# Jonathan Callahan
#
#  15-Nov-1999 Ansley Manke
#  remove refs to ef_utility/*.o  (now in ferret executable)
#
#  ACM 2/2001  debug macros
#  ACM 2/2002  change targets to all and extras; somehow standard
#               not working well w/ linux.

#
# include site specific macro definitions
#
include ../ef_utility/site_specific.mk
 
#
# include platform specific macro definitions
#
include ../ef_utility/platform_specific.mk.$(BUILDTYPE)

#
# Macros
#

.SUFFIXES: .so

#
# Rules
#

.F.so:
	$(FC) $(FFLAGS) -c  $<
	$(LD) $(LD_DYN_FLAGS) $*.o $(SYSLIBS) -o $*.so

#
# Targets
#

all:	add_9.so appende.so avet.so dates.so factorial.so pass_thru.so percent_good_t.so \
	storage.so string_arg.so subtract.so earth_distance.so

debug:
	$(MAKE) "FFLAGS = $(FFLAGS) $(FFLAGS_DEBUG)" "CFLAGS = $(CFLAGS) $(CFLAGS_DEBUG)" all

install:
	cp *.so $(FER_LOCAL_EXTFCNS)

clean:
	-rm -f *.o *.so

#
# End of Makefile
#

=== debian/changelog ===
pyferret (7.5.0-2ubuntu2) focal; urgency=medium

  * No-change upload for netcdff soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 31 Jan 2020 07:20:34 +0100

pyferret (7.5.0-2ubuntu1) focal; urgency=medium

  * Fix build with experimental pango1.0.
  * Fix linking with the Python 3.8 library.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Jan 2020 08:47:41 +0100

pyferret (7.5.0-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:38:31 +0000

pyferret (7.5.0-2) unstable; urgency=medium

  * Drop python-ferret for python2 transition
  * Standards-Version: 4.4.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Jul 2019 13:14:37 +0100

pyferret (7.5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.3.0
  * B-D on gfortran | fortran-compiler
  * Use debhelper 12

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Jun 2019 12:41:41 +0100

=== debian/control ===
Source: pyferret
Standards-Version: 4.4.0
Homepage: http://ferret.pmel.noaa.gov/Ferret/documentation/pyferret
Vcs-Browser: https://salsa.debian.org:/science-team/pyferret
Vcs-Git: https://salsa.debian.org:/science-team/pyferret.git
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
X-Python3-Version: >= 3.6
Build-Depends: debhelper (>= 12),
 gfortran | fortran-compiler,
 pkg-config,
 csh,
 dh-python,
 libreadline-dev, 
 libcurl4-openssl-dev | libcurl-dev, 
 libncurses-dev, 
 libnetcdf-dev (>= 4.3.0),
 libnetcdff-dev,
 libxpm-dev, 
 libxt-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 python3-dev,
 python3-numpy,
 python3-future,
 ferret-vis

Package: python3-ferret
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ferret-vis, ${python3:Depends}, python3-future
Recommends: ferret-datasets, python3-scipy, python3-pyshp
Description: Python3 wrapper for the Ferret visualization and analysis environment,
 Ferret is an interactive computer visualization and analysis environment
 designed to meet the needs of oceanographers and meteorologists analyzing
 large and complex gridded data sets. It can transparently access extensive
 remote Internet data bases using OPeNDAP (formerly known as DODS)
 .
 This is the Python3 wrapper for Ferret

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# magic debhelper rule
%:
	dh $@ --with python3 

# To aid reproducible builds
LC_ALL=C
export LC_ALL

ARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(ARCH)
INSTALLDIR:=$(CURDIR)/debian/tmp

# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
endif

PY3:=$(shell py3versions -d)
PY3nodot:=$(shell py3versions -dv | tr -d '.')

override_dh_auto_build:
	cp debian/platform_specific.mk.debian.$(FC) platform_specific.mk.debian
	cp debian/ef_utility/platform_specific.mk.debian.$(FC) external_functions/ef_utility/platform_specific.mk.debian
	sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e 's%@INSTALLDIR@%${INSTALLDIR}%' \
                < debian/site_specific.mk.in > site_specific.mk
	cp site_specific.mk external_functions/ef_utility

override_dh_auto_install:
	# Need temp. libraries during build.
	mkdir -p $(INSTALLDIR)/lib/$(PY3)
	ln -s $(CURDIR)/install/lib/$(PY3)/site-packages//pyferret/libpyferret.cpython-$(PY3nodot)-$(ARCH).so \
		$(INSTALLDIR)/lib/$(PY3)/libpyferret.so
	# Build and install 
	# Horrible hack breaks The Debian Way. I'm doing the build in the 'install' phase, as i'm installing into debian/tmp
	# Doing it any earlier, and dh_prep will remove debian/tmp. 
	# This means I'm also doing 'test' after the Install, not between during make & install. gack.
	for p in $(PY3) ; do \
		$(MAKE) HOSTTYPE=debian PYTHON_EXE=$$p clean all install ; \
		done
	find debian \( -name '*.pyo' -o -name '*.pyc' \) -delete
	find debian -type d -name __pycache__ -delete
	dh_numpy3
	@echo "Now doing bench tests"
	ln -s debian/pyferret3  $(INSTALLDIR)/lib/$(PY3)/pyferret
	# First build necessary files
	for p in  $(PY3) ; do \
		sed -e 's%@ARCH@%${ARCH}%' \
                -e 's%@LIBDIR@%${LIBDIR}%' \
		-e 's%@CURDIR@%${CURDIR}%' \
                -e "s%@PYTHON@%$$p%" \
                < debian/site_specific.mk.in > site_specific.mk ; \
		PATH=$(INSTALLDIR)/lib/$$p:$(PATH) PYTHONPATH=$(INSTALLDIR)/lib/$$p/site-packages \
		echo "IGNORING TESTS" ;  \
		done

override_dh_auto_test:
	@echo "Dummy test, to avoid calling make. Do test later"

override_dh_auto_clean:
	# use system xpm.h, not supplied ones
	rm -f fer/gui/xpm*.h
	rm -rf ./build ./install
	find . -type l  -delete 
	find . -name '*.o' -o -name '*.so'  -delete
	[ ! -f platform_specific_flags.mk.debian ]  || $(MAKE)  clean HOSTTYPE=debian

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/,\
  filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/PyFerret-$1\.tar\.gz/ \
  https://github.com/NOAA-PMEL/PyFerret/tags .*/v?@ANY_VERSION@\.tar\.gz
